Index: win32ss/user/ntuser/menu.c
===================================================================
--- win32ss/user/ntuser/menu.c	(revision 68654)
+++ win32ss/user/ntuser/menu.c	(working copy)
@@ -1158,6 +3228,141 @@
    return FALSE;
 }
 
+LRESULT WINAPI
+IntPopupMenuWndProc(
+   PWND Wnd,
+   UINT Message,
+   WPARAM wParam,
+   LPARAM lParam,
+   BOOL Ansi)
+{
+  PPOPUPMENU pPopupMenu;
+
+  if (Wnd)
+  {
+     if (!Wnd->fnid)
+     {
+        if (Message != WM_NCCREATE)
+        {
+           return IntDefWindowProc(Wnd, Message, wParam, lParam, Ansi);
+        }
+        Wnd->fnid = FNID_MENU;
+        pPopupMenu = DesktopHeapAlloc( Wnd->head.rpdesk, sizeof(POPUPMENU) );
+        pPopupMenu->posSelectedItem = NO_SELECTED_ITEM;
+        pPopupMenu->spwndPopupMenu = Wnd;
+        ((PMENUWND)Wnd)->ppopupmenu = pPopupMenu;
+        ERR("Pop Up Menu is Setup! Msg %d\n",Message);
+     }
+     else
+     {
+        if (Wnd->fnid != FNID_MENU)
+        {
+           ERR("Wrong window class for Menu!\n");
+           return 0;
+        }
+        pPopupMenu = ((PMENUWND)Wnd)->ppopupmenu;
+     }
+  }
+
+  TRACE("pwnd=%x msg=0x%04x wp=0x%04lx lp=0x%08lx\n", Wnd, Message, wParam, lParam);
+
+  switch(Message)
+    {
+    case WM_CREATE:
+      {
+        CREATESTRUCTW *cs = (CREATESTRUCTW *) lParam;
+        pPopupMenu->spmenu = UserGetMenuObject(cs->lpCreateParams);
+        return 0;
+      }
+
+    case WM_MOUSEACTIVATE:  /* We don't want to be activated */
+      return MA_NOACTIVATE;
+
+    case WM_PAINT:
+      {
+        PAINTSTRUCT ps;
+        IntBeginPaint(Wnd, &ps);
+        MENU_DrawPopupMenu(Wnd, ps.hdc, pPopupMenu->spmenu->head.h);
+        IntEndPaint(Wnd, &ps);
+        return 0;
+      }
+
+    case WM_PRINTCLIENT:
+      {
+         MENU_DrawPopupMenu( Wnd, (HDC)wParam, pPopupMenu->spmenu->head.h);
+         return 0;
+      }
+
+    case WM_ERASEBKGND:
+      return 1;
+
+    case WM_DESTROY:
+      /* zero out global pointer in case resident popup window was destroyed. */
+      /*if (Wnd == top_popup)
+        {
+          top_popup = NULL;
+          top_popup_hmenu = NULL;
+        }*/
+      break;
+
+    case WM_NCDESTROY:
+      {
+      DesktopHeapFree(Wnd->head.rpdesk, pPopupMenu );
+      ((PMENUWND)Wnd)->ppopupmenu = 0;
+      Wnd->fnid = FNID_DESTROY;
+      break;
+      }
+
+    case MM_SETMENUHANDLE:
+      {
+        PMENU pmenu = UserGetMenuObject((HMENU)wParam);
+        if (!pmenu)
+        {
+           ERR("Bad Menu Handle\n");
+           break;
+        }
+        pPopupMenu->spmenu = pmenu;
+        break;
+      }
+
+    case MM_GETMENUHANDLE:
+    case MN_GETHMENU:
+         return (LRESULT)(pPopupMenu ? (pPopupMenu->spmenu ? pPopupMenu->spmenu->head.h : NULL) : NULL);
+
+    default:
+      return IntDefWindowProc(Wnd, Message, wParam, lParam, Ansi);
+    }
+
+  return 0;
+}
+
+
+BOOL FASTCALL
+IntHiliteMenuItem(PWND WindowObject,
+                  PMENU MenuObject,
+                  UINT uItemHilite,
+                  UINT uHilite)
+{
+   PITEM MenuItem;
+   UINT uItem = uItemHilite;
+
+   if (!(MenuItem = MENU_FindItem( &MenuObject, &uItem, uHilite ))) return TRUE;
+
+   if (uHilite & MF_HILITE)
+   {
+      MenuItem->fState |= MF_HILITE;
+   }
+   else
+   {
+      MenuItem->fState &= ~MF_HILITE;
+   }
+   if (MenuObject->iItem == uItemHilite) return TRUE;
+   MENU_HideSubPopups( WindowObject, MenuObject, FALSE, 0 );
+   MENU_SelectItem( WindowObject, MenuObject, uItemHilite, TRUE, 0 );
+
+   return TRUE; // Always returns true!!!!
+}
+
 BOOLEAN APIENTRY
 intGetTitleBarInfo(PWND pWindowObject, PTITLEBARINFO bti)
 {
@@ -1372,39 +3577,18 @@
 
 UINT FASTCALL IntFindSubMenu(HMENU *hMenu, HMENU hSubTarget )
 {
-    PMENU menu;
-    HMENU hSubMenu;
-    UINT i;
-    PITEM item;
-
+    PMENU menu, pSubTarget;
+    UINT Pos;
     if (((*hMenu)==(HMENU)0xffff) ||(!(menu = UserGetMenuObject(*hMenu))))
         return NO_SELECTED_ITEM;
 
-    item = menu->rgItems;
-    for (i = 0; i < menu->cItems; i++, item++)
-    {
-        if (!item->spSubMenu)
-           continue;
-        else
-        {
-           hSubMenu = UserHMGetHandle(item->spSubMenu);
-           if (hSubMenu == hSubTarget)
-           {
-              return i;
-           }
-           else
-           {
-              HMENU hsubmenu = hSubMenu;
-              UINT pos = IntFindSubMenu( &hsubmenu, hSubTarget );
-              if (pos != NO_SELECTED_ITEM)
-              {
-                  *hMenu = hsubmenu;
-                  return pos;
-              }
-           }
-        }
-    }
-    return NO_SELECTED_ITEM;
+    pSubTarget = UserGetMenuObject(hSubTarget);
+
+    Pos = MENU_FindSubMenu(&menu, pSubTarget );
+
+    *hMenu = (menu ? UserHMGetHandle(menu) : NULL);
+
+    return Pos;
 }
 
 
@@ -1601,21 +3785,6 @@
    return( Res);
 }
 
-VOID FASTCALL
-MENU_AdjustMenuItemRect(PMENU menu, PRECTL rect)
-{
-    if (menu->dwArrowsOn)
-    {
-        UINT arrow_bitmap_height;
-        //BITMAP bmp;
-        //GetObjectW(get_up_arrow_bitmap(), sizeof(bmp), &bmp);
-        arrow_bitmap_height = gpsi->oembmi[65].cy; ///// Menu up arrow! OBM_UPARROW DFCS_MENUARROWUP
-        //arrow_bitmap_height = bmp.bmHeight;
-        rect->top += arrow_bitmap_height - menu->iTop;
-        rect->bottom += arrow_bitmap_height - menu->iTop;
-    }
-}
-
 BOOL FASTCALL
 IntGetMenuItemRect(
    PWND pWnd,
@@ -1855,7 +4024,7 @@
       return FALSE;
    }
 
-   *Changed = (Wnd->IDMenu != (UINT) Menu);
+   *Changed = (UlongToHandle(Wnd->IDMenu) != Menu);
    if (! *Changed)
    {
       return TRUE;
@@ -1863,8 +4032,8 @@
 
    if (Wnd->IDMenu)
    {
-      OldMenu = IntGetMenuObject((HMENU) Wnd->IDMenu);
-      ASSERT(NULL == OldMenu || OldMenu->hWnd == Wnd->head.h);
+      OldMenu = IntGetMenuObject(UlongToHandle(Wnd->IDMenu));
+      ASSERT(NULL == OldMenu || OldMenu->hWnd == UserHMGetHandle(Wnd));
    }
    else
    {
@@ -1899,7 +4068,7 @@
    Wnd->IDMenu = (UINT) Menu;
    if (NULL != NewMenu)
    {
-      NewMenu->hWnd = Wnd->head.h;
+      NewMenu->hWnd = UserHMGetHandle(Wnd);
       IntReleaseMenuObject(NewMenu);
    }
    if (NULL != OldMenu)
@@ -1912,6 +4081,7 @@
 }
 
 
+
 /* FUNCTIONS *****************************************************************/
 
 /*
@@ -2221,6 +4391,30 @@
  * @implemented
  */
 BOOL APIENTRY
+NtUserEndMenu(VOID)
+{
+   PWND pWnd;
+   TRACE("Enter NtUserEndMenu\n");
+   UserEnterExclusive();
+   if ( gptiCurrent->pMenuState->pGlobalPopupMenu )
+   {
+       pWnd = IntGetMSWND(gptiCurrent->pMenuState);
+       if (pWnd)
+       {
+          UserPostMessage( UserHMGetHandle(pWnd), WM_CANCELMODE, 0, 0);
+       }
+       else
+          gptiCurrent->pMenuState->fInsideMenuLoop = FALSE;
+   }
+   UserLeave();
+   TRACE("Leave NtUserEndMenu\n");
+   return TRUE;
+}
+
+/*
+ * @implemented
+ */
+BOOL APIENTRY
 NtUserGetMenuBarInfo(
    HWND hwnd,
    LONG idObject,
@@ -2492,7 +4686,7 @@
    PWND Window;
    DECLARE_RETURN(BOOLEAN);
 
-   TRACE("Enter NtUserHiliteMenuItem\n");
+   ERR("Enter NtUserHiliteMenuItem\n");
    UserEnterExclusive();
 
    if(!(Window = UserGetWindowObject(hWnd)))
@@ -2519,6 +4713,64 @@
 /*
  * @implemented
  */
+DWORD
+APIENTRY
+NtUserDrawMenuBarTemp(
+   HWND hWnd,
+   HDC hDC,
+   PRECT pRect,
+   HMENU hMenu,
+   HFONT hFont)
+{
+   PMENU Menu;
+   PWND Window;
+   RECT Rect;
+   NTSTATUS Status = STATUS_SUCCESS;
+   DECLARE_RETURN(DWORD);
+
+   TRACE("Enter NtUserDrawMenuBarTemp\n");
+   UserEnterExclusive();
+
+   if(!(Window = UserGetWindowObject(hWnd)))
+   {
+      EngSetLastError(ERROR_INVALID_WINDOW_HANDLE);
+      RETURN(0);
+   }
+
+   if(!(Menu = UserGetMenuObject(hMenu)))
+   {
+      EngSetLastError(ERROR_INVALID_MENU_HANDLE);
+      RETURN(0);
+   }
+
+   _SEH2_TRY
+   {
+      ProbeForRead(pRect, sizeof(RECT), sizeof(ULONG));
+      RtlCopyMemory(&Rect, pRect, sizeof(RECT));
+   }
+   _SEH2_EXCEPT(EXCEPTION_EXECUTE_HANDLER)
+   {
+      Status = _SEH2_GetExceptionCode();
+   }
+   _SEH2_END;
+
+   if (Status != STATUS_SUCCESS)
+   {
+      SetLastNtError(Status);
+      RETURN(0);
+   }
+
+   RETURN( IntDrawMenuBarTemp(Window, hDC, &Rect, Menu, hFont));
+
+CLEANUP:
+   TRACE("Leave NtUserDrawMenuBarTemp, ret=%u\n",_ret_);
+   UserLeave();
+   END_CLEANUP;
+}
+
+/*
+ * @implemented
+ */
 int APIENTRY
 NtUserMenuItemFromPoint(
    HWND hWnd,
@@ -2552,11 +4804,14 @@
    for (i = 0; i < Menu->cItems; i++, mi++)
    {
       RECTL Rect;
+
       Rect.left   = mi->xItem;
       Rect.top    = mi->yItem;
-      Rect.right  = mi->cxItem; // Do this for now......
+      Rect.right  = mi->cxItem;
       Rect.bottom = mi->cyItem;
-      //MENU_AdjustMenuItemRect(Menu, &Rect); Need gpsi OBMI via callback!
+
+      MENU_AdjustMenuItemRect(Menu, &Rect);
+
       if (RECTL_bPointInRect(&Rect, X, Y))
       {
          break;
@@ -2807,4 +5062,21 @@
    END_CLEANUP;
 }
 
+/*
+ * @implemented
+ */
+BOOL APIENTRY
+NtUserTrackPopupMenuEx(
+   HMENU hMenu,
+   UINT fuFlags,
+   int x,
+   int y,
+   HWND hWnd,
+   LPTPMPARAMS lptpm)
+{
+   STUB
+
+   return FALSE;
+}
+
 /* EOF */
Index: win32ss/user/ntuser/menu.h
===================================================================
--- win32ss/user/ntuser/menu.h	(revision 68654)
+++ win32ss/user/ntuser/menu.h	(working copy)
@@ -101,3 +101,5 @@
 PITEM FASTCALL MENU_FindItem( PMENU *pmenu, UINT *nPos, UINT wFlags );
 BOOL FASTCALL IntMenuItemInfo(PMENU Menu, UINT Item, BOOL ByPosition, PROSMENUITEMINFO UnsafeItemInfo, BOOL SetOrGet, PUNICODE_STRING lpstr);
 BOOL FASTCALL IntSetMenu(PWND Wnd,HMENU Menu,BOOL *Changed);
+UINT MENU_DrawMenuBar( HDC hDC, LPRECT lprect, PWND pWnd, BOOL suppress_draw );
+BOOL MenuInit(VOID);
Index: win32ss/user/ntuser/message.c
===================================================================
--- win32ss/user/ntuser/message.c	(revision 68654)
+++ win32ss/user/ntuser/message.c	(working copy)
@@ -136,6 +136,9 @@
     { WM_WINDOWPOSCHANGING, sizeof(WINDOWPOS), MMS_FLAG_READWRITE },
     { WM_SIZING, sizeof(RECT), MMS_FLAG_READWRITE },
     { WM_MOVING, sizeof(RECT), MMS_FLAG_READWRITE },
+    { WM_MEASUREITEM, sizeof(MEASUREITEMSTRUCT), MMS_FLAG_READWRITE },
+    { WM_DRAWITEM, sizeof(DRAWITEMSTRUCT), MMS_FLAG_READWRITE },
+    { WM_HELP, sizeof(HELPINFO), MMS_FLAG_READWRITE },
 };
 
 static PMSGMEMORY FASTCALL
